// Generated by CoffeeScript 1.10.0
(function() {
  var calculator, gridarray, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  calculator = require('./common/calculator');

  gridarray = require('./common/gridarray');

  module.exports = function(pattern, element) {
    var bodyLength, bodyWidth, d, dx, dy, fontSize, height, housing, leadCount, lineWidth, padParams, r, ref, ref1, ref2, ref3, settings, x, y;
    housing = element.housing;
    settings = pattern.settings;
    leadCount = (ref = housing.leadCount) != null ? ref : 2 * (housing.rowCount + housing.columnCount);
    height = (ref1 = housing.height.max) != null ? ref1 : housing.height;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["BGA%d%s%dP%dX%d_%dX%dX%d", leadCount, settings.ball.collapsible ? 'C' : 'N'].concat(slice.call([housing.pitch * 100, housing.columnCount, housing.rowCount, housing.bodyLength.nom * 100, housing.bodyWidth.nom * 100, height * 100].map((function(_this) {
        return function(a) {
          return Math.round(a);
        };
      })(this)))));
    }
    padParams = calculator.bga(pattern, housing);
    padParams.rowPitch = (ref2 = housing.rowPitch) != null ? ref2 : housing.pitch;
    padParams.columnPitch = (ref3 = housing.columnPitch) != null ? ref3 : housing.pitch;
    padParams.rowCount = housing.rowCount;
    padParams.columnCount = housing.columnCount;
    padParams.pad = {
      type: 'smd',
      width: padParams.width,
      height: padParams.height,
      shape: 'circle',
      mask: 0.001,
      paste: -0.001
    };
    pattern.setLayer(['topCopper', 'topMask', 'topPaste']);
    gridarray(pattern, element, padParams);
    pattern.setLayer('topSilkscreen');
    lineWidth = settings.lineWidth.silkscreen;
    pattern.setLineWidth(lineWidth);
    bodyWidth = housing.bodyWidth.nom;
    bodyLength = housing.bodyLength.nom;
    x = bodyWidth / 2;
    y = bodyLength / 2;
    dx = x - padParams.columnPitch * (padParams.columnCount / 2 - 0.5);
    dy = y - padParams.rowPitch * (padParams.rowCount / 2 - 0.5);
    d = Math.min(dx, dy);
    pattern.addLine({
      x1: -x,
      y1: -y + d,
      x2: -x + d,
      y2: -y
    });
    pattern.addLine({
      x1: -x + d,
      y1: -y,
      x2: x,
      y2: -y
    });
    pattern.addLine({
      x1: x,
      y1: -y,
      x2: x,
      y2: y
    });
    pattern.addLine({
      x1: x,
      y1: y,
      x2: -x,
      y2: y
    });
    pattern.addLine({
      x1: -x,
      y1: y,
      x2: -x,
      y2: -y + d
    });
    r = 0.25;
    pattern.addCircle({
      x: -x,
      y: -y,
      radius: r / 2,
      lineWidth: r
    });
    fontSize = settings.fontSize.refDes;
    pattern.addAttribute('refDes', {
      x: 0,
      y: -bodyLength / 2 - fontSize / 2 - 2 * lineWidth,
      halign: 'center',
      valign: 'center'
    });
    pattern.setLayer('topAssembly');
    pattern.setLineWidth(settings.lineWidth.assembly);
    pattern.addLine({
      x1: -x,
      y1: -y + d,
      x2: -x + d,
      y2: -y
    });
    pattern.addLine({
      x1: -x + d,
      y1: -y,
      x2: x,
      y2: -y
    });
    pattern.addLine({
      x1: x,
      y1: -y,
      x2: x,
      y2: y
    });
    pattern.addLine({
      x1: x,
      y1: y,
      x2: -x,
      y2: y
    });
    pattern.addLine({
      x1: -x,
      y1: y,
      x2: -x,
      y2: -y + d
    });
    fontSize = settings.fontSize.value;
    return pattern.addAttribute('value', {
      text: pattern.name,
      x: 0,
      y: bodyLength / 2 + fontSize / 2 + 0.5,
      halign: 'center',
      valign: 'center'
    });
  };

}).call(this);
